VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "INI"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

'    INI-.
'     ,
'   Win.ini    .

Private Declare Function GetPrivateProfileInt Lib "kernel32" Alias "GetPrivateProfileIntA" (ByVal lpApplicationName As String, ByVal lpKeyName As String, ByVal nDefault As Long, ByVal lpFileName As String) As Long
Private Declare Function GetPrivateProfileString Lib "kernel32" Alias "GetPrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpDefault As String, ByVal lpReturnedString As String, ByVal nSize As Long, ByVal lpFileName As String) As Long
Private Declare Function GetPrivateProfileSection Lib "kernel32" Alias "GetPrivateProfileSectionA" (ByVal lpAppName As String, ByVal lpReturnedString As String, ByVal nSize As Long, ByVal lpFileName As String) As Long
Private Declare Function GetPrivateProfileSectionNames Lib "kernel32.dll" Alias "GetPrivateProfileSectionNamesA" (ByVal lpszReturnBuffer As String, ByVal nSize As Long, ByVal lpFileName As String) As Long
Private Declare Function WritePrivateProfileSection Lib "kernel32" Alias "WritePrivateProfileSectionA" (ByVal lpAppName As String, ByVal lpString As String, ByVal lpFileName As String) As Long
Private Declare Function WritePrivateProfileString Lib "kernel32" Alias "WritePrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpString As Any, ByVal lpFileName As String) As Long

Private Declare Function GetProfileInt Lib "kernel32" Alias "GetProfileIntA" (ByVal lpAppName As String, ByVal lpKeyName As String, ByVal nDefault As Long) As Long
Private Declare Function GetProfileString Lib "kernel32" Alias "GetProfileStringA" (ByVal lpAppName As String, ByVal lpKeyName As String, ByVal lpDefault As String, ByVal lpReturnedString As String, ByVal nSize As Long) As Long
Private Declare Function GetProfileSection Lib "kernel32" Alias "GetProfileSectionA" (ByVal lpAppName As String, ByVal lpReturnedString As String, ByVal nSize As Long) As Long
Private Declare Function WriteProfileString Lib "kernel32" Alias "WriteProfileStringA" (ByVal lpszSection As String, ByVal lpszKeyName As String, ByVal lpszString As String) As Long
Private Declare Function WriteProfileSection Lib "kernel32" Alias "WriteProfileSectionA" (ByVal lpAppName As String, ByVal lpString As String) As Long

Private mFile As String
Private buf As String
Private Const BufSize As Integer = 32767

Property Get File() As String
  File = mFile
End Property

Property Let File(F As String)
  mFile = F
End Property

Property Get Sections(Optional ByVal InWinINI As Boolean = False) As Variant
  buf = Space$(BufSize)
  Sections = Split(Left$(buf, GetPrivateProfileSectionNames(buf, BufSize, IIf(InWinINI, vbNullString, mFile))), vbNullChar)
End Property

Property Get Values(Section As String, Optional ByVal InWinINI As Boolean = False) As Variant
  buf = Space$(BufSize)
  If InWinINI Then Values = Split(Left$(buf, GetProfileSection(Section, buf, BufSize)), vbNullChar) Else Values = Split(Left$(buf, GetPrivateProfileSection(Section, buf, BufSize, mFile)), vbNullChar)
End Property

Property Let Values(Section As String, Optional ByVal InWinINI As Boolean = False, ValuesString As Variant)
  '   "Key1=Value1" + vbNullChar + "Key2=Value2" + ...
  If InWinINI Then WriteProfileSection Section, CStr(ValuesString) Else WritePrivateProfileSection Section, CStr(ValuesString), mFile
End Property

Property Get Number(Section As String, Value As String, Optional ByVal InWinINI As Boolean = False) As Long
  If InWinINI Then Number = GetProfileInt(Section, Value, 0) Else Number = GetPrivateProfileInt(Section, Value, 0, mFile)
End Property

Property Let Number(Section As String, Value As String, Optional ByVal InWinINI As Boolean = False, Num As Long)
  If InWinINI Then WriteProfileString Section, Value, CStr(Num) Else WritePrivateProfileString Section, Value, CStr(Num), mFile
End Property

Property Get StringValue(Section As String, Value As String, Optional ByVal InWinINI As Boolean = False) As String
  buf = Space$(BufSize)
  If InWinINI Then StringValue = Left$(buf, GetProfileString(Section, Value, vbNullString, buf, BufSize)) Else StringValue = Left$(buf, GetPrivateProfileString(Section, Value, vbNullString, buf, BufSize, mFile))
End Property

Property Let StringValue(Section As String, Value As String, Optional ByVal InWinINI As Boolean = False, S As String)
  If InWinINI Then WriteProfileString Section, Value, S Else WritePrivateProfileString Section, Value, S, mFile
End Property





